ALTER PROCEDURE [HM].[GetROforDK]
@date DATE,
@DepartmentId INT,
@subtyp INT,
@typ_dk VARCHAR(40),

@IdRO INT OUT
AS
BEGIN
	DECLARE @PeriodicSaleReportId INT;

	DECLARE
		@Department VARCHAR(40),
        @PeriodicSaleReportDocumentType VARCHAR(30),
        @PeriodicSaleReportDocumentName VARCHAR(30),
        @periodicSaleReportNumerationSeries VARCHAR(30),
        @billingPeriod SMALLINT,
        @datefrom DATE,
        @dateTo DATE,
        @billingPeriodType INT,
        @billingPeriodSerie INT,
        @charakter SMALLINT;

SELECT @billingPeriodType = billingPeriodType, @billingPeriodSerie = billingPeriodSerie FROM HM.TD WHERE kod = @typ_dk;
IF (ISNULL(@billingPeriodType, 0 ) <> 0 AND ISNULL(@billingPeriodSerie, 0 ) <> 0)
BEGIN
    SELECT @PeriodicSaleReportDocumentType = kod FROM HM.TD WHERE id = @billingPeriodType;
    SELECT @periodicSaleReportNumerationSeries = kod FROM HM.SD WHERE id = @billingPeriodSerie;
END

IF (ISNULL(@PeriodicSaleReportDocumentType, '') = '' AND ISNULL(@periodicSaleReportNumerationSeries, '') = '')
BEGIN
    SELECT @PeriodicSaleReportDocumentType = CASE WHEN @subtyp=50 THEN nazwisko ELSE naglowek END,
           @periodicSaleReportNumerationSeries =  CASE WHEN @subtyp=50 THEN imie ELSE nip END,
	       @department=kod
    FROM HM.KH
    WHERE id = @DepartmentId;
END

SELECT @billingPeriod = billingPeriod,
       @PeriodicSaleReportDocumentName = nazwa,
       @charakter = charakter
FROM HM.TD
WHERE kod = @PeriodicSaleReportDocumentType;


IF @billingPeriod = 1
BEGIN
    SET @datefrom = @date;
    SET @dateTo = @date;
END;
IF @billingPeriod = 2
BEGIN
    SELECT @datefrom = hm.fn_GetWeekStartDate(@date),
           @dateTo = hm.fn_GetWeekEndDate(@date);
END;
IF @billingPeriod = 3
BEGIN
    SELECT @datefrom = DATEADD(DAY, 1, EOMONTH(@date, -1)),
           @dateTo = EOMONTH(@date);
END;


SELECT @PeriodicSaleReportId = Id
FROM HM.PeriodicSaleReports
WHERE TRY_CONVERT(DATE, DateFrom) = @datefrom
      AND @dateTo = DateTo
      AND DepartmentId = @DepartmentId
      AND PeriodType = @billingPeriod
	  AND DocumentType = @PeriodicSaleReportDocumentType;

		SET @IdRO = @PeriodicSaleReportId

END
RETURN @PeriodicSaleReportId