﻿ALTER VIEW [HM].[IncorrectlyMigratedDocumentsCardIndexView]
AS
WITH cte
AS (SELECT MCT.Id AS Id,
          MCT.IdDokMag AS IdDok,
         CASE WHEN (MCT.TypDokumentu = 0) THEN 'Dokument sprzedaży'
              WHEN (MCT.TypDokumentu = 1) THEN 'Dokument magazynowy'
              WHEN (MCT.TypDokumentu = 2) THEN 'Zamówienie'
              WHEN (MCT.TypDokumentu = 3) THEN 'Dokument zakupu'
              ELSE 'Nieokreślony' END AS DocumentType,
          MCT.KodDok AS DocumentNumber,
          MCT.data AS DocumentDate,
ISNULL(ABS( CAST(CASE WHEN (MCT.TypDokumentu = 0) THEN dk.netto+dk.vat
                      WHEN (MCT.TypDokumentu = 1) THEN mg.wartoscWz
                      WHEN (MCT.TypDokumentu = 2) THEN zo.netto+zo.vat
                      WHEN (MCT.TypDokumentu = 3) THEN kd.netto+kd.vat
                      ELSE 0
END AS DECIMAL(18, 4)) ),0) AS ValueGross,
		 CASE WHEN (MCT.TypDokumentu = 0) THEN ISNULL(dk.khid, dk.khadid)
              WHEN (MCT.TypDokumentu = 1) THEN ISNULL(mg.khid, mg.khadid)
              WHEN (MCT.TypDokumentu = 2) THEN ISNULL(zo.khid, zo.khadid)
              WHEN (MCT.TypDokumentu = 3) THEN ISNULL(kd.khid, zo.khadid)
              ELSE 0 END AS khid,
          MCT.Description AS DocDescription
FROM [HM].[MigrationCheckTable] AS MCT
LEFT JOIN hm.dk dk ON MCT.IdDokMag = dk.id AND MCT.TypDokumentu = 0
LEFT JOIN hm.mg mg ON MCT.IdDokMag = mg.id AND MCT.TypDokumentu = 1
LEFT JOIN hm.zo zo ON MCT.IdDokMag = zo.id AND MCT.TypDokumentu = 2
LEFT JOIN hm.dk kd ON MCT.IdDokMag = kd.id AND MCT.TypDokumentu = 3)
SELECT cte.Id,
       cte.IdDok,
       cte.DocumentType,
       cte.DocumentNumber,
       cte.DocumentDate,
       cte.ValueGross,
       cte.DocDescription,
       cte.khid,
       Contractors.Shortcut AS ContractorCode
FROM cte
LEFT JOIN SSCommon.STContractors Contractors ON cte.khid = Contractors.id;
--tymczasowo pobierane z DK, docelowo z MigrationCheckTable


