﻿ALTER PROCEDURE HM.getRoCode
@DKid INT,
@date DATE,
@roId VARCHAR(30) OUTPUT
AS
BEGIN
    --Zmienne potrzebne do sprawdzeń
    DECLARE @PeriodicSalesReportStartDate DATE = '2020-10-01';
    DECLARE @DocumentSaleDate DATE,
            @DocCharakter INT,
            @RecipientWorkParameter DECIMAL(10, 2),
            @DocumentGrossValue DECIMAL(10, 2),
            @DocumentCanecled INT,
            @IsContractorWithNIP BIT,
			@bufor SMALLINT;

	DECLARE @PeriodicSaleReportId INT;
		/* - zwracamy id raportu okresowego 
		*/
	DECLARE @DepartmentId INT,
		@Department VARCHAR(40),
		@tUser VARCHAR(40),
        @PeriodicSaleReportDocumentType VARCHAR(30),
        @periodicSaleReportNumerationSeries VARCHAR(30),
        @billingPeriod SMALLINT,
        @datefrom DATE,
        @dateTo DATE,
		@aktywny SMALLINT,
		@flag SMALLINT,
		@subtyp INT,
        @billingPeriodType INT,
        @billingPeriodSerie INT,
        @charakter SMALLINT,
		@PeriodicSaleReportDocumentName VARCHAR(30);

	--Odczyt parametru
    SELECT @RecipientWorkParameter = ISNULL( ( SELECT TRY_CAST(opis AS DECIMAL(10, 2))
                                                 FROM HM.ZZ
                                                WHERE id2 = 1288
                                             ),
                                             0.0
                                           );

    SELECT @DocumentSaleDate = CASE WHEN subtyp=50 THEN datasp WHEN dok.subtyp=51 THEN dok.data ELSE dok.datasp end,
           @DocCharakter = subtyp,
           @DocumentGrossValue = walBrutto,
		   @bufor= dok.bufor,
           @aktywny= dok.aktywny,
           @IsContractorWithNIP = CASE 
									  WHEN contractor.nip LIKE 'P:%' THEN 0
                                      WHEN contractor.nip = '' THEN 0
                                      ELSE 1
                                  END,
           @DocumentCanecled = CASE WHEN dok.anulowany <> 0 AND dok.anulowany <> 3 THEN 1 ELSE 0 END
    FROM HM.DK dok
        LEFT JOIN HM.AD contractor
            ON dok.khadid = contractor.id
    WHERE dok.id = @DKid;
	SET @flag = (SELECT flag FROM HM.DK WHERE id = @DKid)
	IF((@flag & 0x0080) = 0) -- jestli metoda memorialowa to bierzemy date wejscia do rejestru 	
		SET @DocumentSaleDate = (SELECT datarej FROM HM.DK WHERE id = @DKid)

    -- aktywna wystawiona korekta paragonu bezwarunkowo wysylana zbiorczo
    IF (((@DocCharakter = 50) AND
         (@DocumentSaleDate >= @PeriodicSalesReportStartDate) AND
         (@IsContractorWithNIP = 0 OR ABS(@DocumentGrossValue) > @RecipientWorkParameter) AND
         (@DocumentCanecled = 0)
        )
        OR
        (@DocCharakter = 51)
       )
       AND @bufor=0 AND @aktywny = 1
    BEGIN
        SELECT @DepartmentId = magazyn,@tUser=users.LoginName, @subtyp = subtyp
		FROM HM.DK dk
		LEFT JOIN SSCommon.STUsers users ON dk.wystawil=users.id
		WHERE dk.id = @DKid;

		SELECT @billingPeriodType = billingPeriodType, @billingPeriodSerie = billingPeriodSerie FROM HM.TD WHERE kod = (SELECT typ_dk FROM HM.DK WHERE id = @DKid);
		IF (ISNULL(@billingPeriodType, 0 ) <> 0 AND ISNULL(@billingPeriodSerie, 0 ) <> 0)
		BEGIN
			SELECT @PeriodicSaleReportDocumentType = kod FROM HM.TD WHERE id = @billingPeriodType;
			SELECT @periodicSaleReportNumerationSeries = kod FROM HM.SD WHERE id = @billingPeriodSerie;
		END

		IF (ISNULL(@PeriodicSaleReportDocumentType, '') = '' AND ISNULL(@periodicSaleReportNumerationSeries, '') = '')
		BEGIN
			SELECT @PeriodicSaleReportDocumentType = CASE WHEN @subtyp=50 THEN nazwisko ELSE naglowek END,
				   @periodicSaleReportNumerationSeries =  CASE WHEN @subtyp=50 THEN imie ELSE nip END,
				   @department=kod
			FROM HM.KH
			WHERE id = @DepartmentId;
		END

		SELECT @billingPeriod = billingPeriod,
			   @PeriodicSaleReportDocumentName = nazwa,
			   @charakter = charakter
		FROM HM.TD
		WHERE kod = @PeriodicSaleReportDocumentType;


		IF @billingPeriod = 1
		BEGIN
			SET @datefrom = @date;
			SET @dateTo = @date;
		END;
		IF @billingPeriod = 2
		BEGIN
			SELECT @datefrom = hm.fn_GetWeekStartDate(@date),
				   @dateTo = hm.fn_GetWeekEndDate(@date);
		END;
		IF @billingPeriod = 3
		BEGIN
			SELECT @datefrom = DATEADD(DAY, 1, EOMONTH(@date, -1)),
				   @dateTo = EOMONTH(@date);
		END;


		SELECT @PeriodicSaleReportId = Id
		FROM HM.PeriodicSaleReports
		WHERE TRY_CONVERT(DATE, DateFrom) = @datefrom
			  AND @dateTo = DateTo
			  AND DepartmentId = @DepartmentId
			  AND PeriodType = @billingPeriod
			  AND DocumentType = @PeriodicSaleReportDocumentType;

		IF @PeriodicSaleReportId IS NULL
		BEGIN
			--generowanie kodu
			DECLARE @DocumentTypeId INT, @DocumentNumerationCode VARCHAR(10);

			DECLARE @userId INT, @contractorId INT, @departmentIdnum INT, @currency VARCHAR(3), @buffer SMALLINT, @datenum DATETIME;

			DECLARE @CONSTtableId SMALLINT = 17; -- numer tabeli 
			DECLARE @CONSTtypeTD SMALLINT = 0; -- pole typ w tabeli TD: 0 - sprzedaż, 1 - zakup, 2 - magazyn, 3 - płatności, 4 - zamówienie obce, 5 - zamówienie własne

			SELECT 
				   @DocumentTypeId  = t.id,
				   @DocumentNumerationCode = @periodicSaleReportNumerationSeries,
				   @userId 			= d.wystawil,
				   @contractorId	= d.khid,
				   @departmentIdnum	= d.magazyn,
				   @currency		= d.waluta,
				   @buffer			= d.bufor,
				   @datenum			= @date
			FROM HM.DK d
				JOIN HM.TD t ON t.kod = @PeriodicSaleReportDocumentType AND t.typ = @CONSTtypeTD
			WHERE d.id = @DKid;

			DECLARE @code VARCHAR(40), @numberInSeries INT, @periodnum SMALLINT, @nSeriaDzial INT;

			EXECUTE hm.GenerateDocumentNumber @DKid, @DocumentTypeId, @DocumentNumerationCode, @userId, @contractorId, @departmentIdnum, @currency, @buffer, @datenum, @CONSTtableId,
												@code OUT, @numberInSeries OUT, @periodnum OUT, @nSeriaDzial OUT
            SET @roId = @code;                       
			--generowanie kodu			
		END;
		ELSE
		BEGIN
			SELECT @roId = Code FROM HM.PeriodicSaleReports WHERE id = @PeriodicSaleReportId;
		END;
    END;
	ELSE
		SET @roId = 'brak'
END;