﻿ALTER PROCEDURE HM.stdhm_update_dk
@id int, @flag smallint, @aktywny smallint, @subtyp smallint, @typ smallint,
@znacznik smallint, @rodzaj int, @katalog int, @info smallint, @wystawil int,
@kod varchar(41), @seria varchar(6), @serianr int, @okres smallint, @seriadzial int,
@nazwa varchar(41), @data datetime, @datasp datetime, @datawplywu datetime, @opis varchar(81),
@khid int, @khadid int, @odid int, @odadid int,
@ok smallint, @rr smallint, @wplaty float, @rabat float, @plattyp int, @plattermin datetime,
@netto float, @vat float, @odebrane varchar(41), @typ_dk varchar(4), @grupacen smallint,
@rejestrVat int, @rejestrVat2 int, @iddokkoryg int, @wartoscSp float, @exp_fk smallint,
@waluta varchar(4), @kurs float, @zyskdod float, @paragon int, @kod_obcy varchar(41),
@magazyn int, @rozlmg smallint, @formaplatn int, @schemat varchar(5), @datarej datetime, @datarej2 datetime,
@bufor smallint, @super int, @anulowany smallint, @createdBy int, @createdDate datetime, @modifiedBy int,
@modifiedDate datetime, @walNetto float, @walBrutto float, @wartPrzychod float, @kursDoch float,
@eFaktura smallint, @statusRDF smallint, @guid varchar(38), @data_obcy datetime, @koszt float, @kosztAproksymowany float, 
@statusFK smallint, @typceny smallint, @jpk smallint, @importKasa bit, @splitPayment bit, @forceSP bit, @checkWL bit, @accountId int,
@jpk_v7 varchar(256), @importKasaZbiorczy bit, @IdPeriodicSaleReport int, @fiscalDeviceNo varchar(40)
AS
	DECLARE @oldDataSp DATETIME	
	DECLARE @oldDat DATETIME
	DECLARE @oldROId INT

	SELECT @oldDat = datasp FROM DK WHERE @id = id
	SELECT @oldROId = idPeriodicSaleReport FROM DK WHERE @id = id

	SELECT @guid = REPLACE( REPLACE( @guid, '{', '' ), '}', '' ) 
	IF @guid NOT LIKE(	REPLICATE( '[0-9A-Fa-f]', 8 ) + '-' + 
						REPLICATE( '[0-9A-Fa-f]', 4 ) + '-' + 
						REPLICATE( '[0-9A-Fa-f]', 4 ) + '-' + 
						REPLICATE( '[0-9A-Fa-f]', 4 ) + '-' + 
						REPLICATE( '[0-9A-Fa-f]', 12 )
					 )
	BEGIN
		-- Ignore invalid guid
		SELECT @guid = guid FROM DK WHERE id = @id
	END
	
	IF (@subtyp IN (134, 135, 150, 151))
	BEGIN
		SELECT @oldDataSp = datasp FROM DK WHERE @id = id
	END	

	DECLARE @dataZest1 datetime
	SELECT @dataZest1 = CASE WHEN @subtyp IN (134, 135, 150, 151) THEN @datasp ELSE @data END

	SET @modifiedDate = GETDATE()
	UPDATE DK
	SET flag = @flag, aktywny = @aktywny, subtyp = @subtyp, typ = @typ, znacznik = @znacznik,
	rodzaj = @rodzaj, katalog = @katalog, info = @info, wystawil = @wystawil, kod = @kod,
	seria = @seria, serianr = @serianr, okres = @okres, seriadzial = @seriadzial, nazwa = @nazwa,
	data = @data, datasp = @datasp, datawplywu = @datawplywu, dataZest1 = @dataZest1, opis = @opis,
	khid = @khid, khadid = @khadid, odid = @odid, odadid = @odadid, ok = @ok, rr = @rr,
	wplaty = @wplaty, rabat = @rabat, plattyp = @plattyp, plattermin = @plattermin, netto = @netto,
	vat = @vat, odebrane = @odebrane, typ_dk = @typ_dk, grupacen = @grupacen, rejestrVat = @rejestrVat,
	rejestrVat2 = @rejestrVat2, iddokkoryg = @iddokkoryg, wartoscSp = @wartoscSp,
	exp_fk = @exp_fk, waluta = @waluta, kurs = @kurs, zyskdod = @zyskdod, paragon = @paragon,
	kod_obcy = @kod_obcy, magazyn = @magazyn, rozlmg = @rozlmg, formaplatn = @formaplatn, schemat = @schemat,
	datarej = @datarej, datarej2 = @datarej2, bufor = @bufor, super = @super, anulowany = @anulowany,
	modifiedBy = @modifiedBy, modifiedDate = @modifiedDate,
	walNetto = @walNetto, walBrutto = @walBrutto, wartPrzychod = @wartPrzychod, kursDoch = @kursDoch,
	eFaktura = @eFaktura, statusRDF = @statusRDF, guid = @guid, data_obcy = @data_obcy, koszt = @koszt, 
	kosztAproksymowany = @kosztAproksymowany, statusFK = @statusFK, typceny = @typceny, jpk = @jpk, importKasa = @importKasa, 
	splitPayment = @splitPayment, forceSP = @forceSP, checkWL = @checkWL, accountId = @accountId,
	jpk_v7 = @jpk_v7, importKasaZbiorczy = @importKasaZbiorczy, IdPeriodicSaleReport = @IdPeriodicSaleReport, fiscalDeviceNo = @fiscalDeviceNo
	WHERE @id = id
	IF ((0 = @bufor) AND (0 = (0x0100 & @flag)))
	BEGIN
		EXEC hm_DP_PrzeliczZyskKoszt @id, 0
	END
	IF @bufor = 0 AND @typ IN (0, 202) AND NOT EXISTS (SELECT * FROM HW WHERE iddk = @id and typdk = 16) BEGIN
		INSERT INTO HW (iddk, typdk) values (@id,16)
	END
	IF ((0 = @bufor) AND (@subtyp IN (135, 136, 137, 151, 152, 153)))
	BEGIN
		DECLARE @idKontraktu INT
		EXEC @idKontraktu = hm_ZZ_GetIdKontraktu @id, 16
		EXEC hm_DK_SetKontraktRozl @idKontraktu
	END

	IF ((0 = @bufor) AND (ISNULL(@datasp, '9990-12-31') <> ISNULL(@oldDataSp, '9990-12-31')))

	BEGIN
		IF (@subtyp IN (134, 150))
		BEGIN
			UPDATE DK
			SET datasp = @datasp, dataZest1 = @datasp
			WHERE iddokkoryg = @id
			INSERT INTO LOCAL_LOG (baseName, rec_id, operation, term) SELECT 'DK', DK.id, 3, @@SPID FROM DK WHERE idDokKoryg = @id
		END
		IF (@subtyp IN (135, 151))
		BEGIN
			UPDATE DK
			SET datasp = @datasp, dataZest1 = @datasp
			WHERE iddokkoryg = @iddokkoryg AND id > @id
			INSERT INTO LOCAL_LOG (baseName, rec_id, operation, term) SELECT 'DK', DK.id, 3, @@SPID FROM DK WHERE iddokkoryg = @iddokkoryg AND id > @id
		END
	END
	IF @typ = 110
	BEGIN
		UPDATE SalesKinds SET kod = @kod WHERE KindId = @id
	END

	--updateRO
	DECLARE @oldDkRo VARCHAR(30)
	
	IF EXISTS (SELECT Code FROM HM.PeriodicSaleReports WHERE id = (SELECT IdPeriodicSaleReport FROM HM.DK WHERE id = @id))
		SELECT @oldDkRo = Code FROM HM.PeriodicSaleReports WHERE id = (SELECT IdPeriodicSaleReport FROM HM.DK WHERE id = @id)
	ELSE 
		SET @oldDkRo = 'brak'

	DECLARE @newDkRo VARCHAR(30)
	exec HM.getRoCode @id, @datasp, @newDkRo OUTPUT

	IF(@newDkRo <> 'brak') -- czy dokument bedzie ro
	BEGIN
		IF(@oldDkRo = 'brak') 
		BEGIN
			IF ((@exp_fk & 0x01) = 0) EXEC hm.IsDocumentAsPeriodicSaleReport @DKid = @id
		END
		ELSE
		BEGIN
			IF(@oldDkRo <> @newDkRo)
			BEGIN
				
				UPDATE HM.DK SET IdPeriodicSaleReport = NULL WHERE id  = @id
				IF ((SELECT COUNT(id) FROM hm.DK WHERE IdPeriodicSaleReport = @IdPeriodicSaleReport) = 0)
				BEGIN
					DELETE FROM hm.PeriodicSaleReports WHERE Id = @IdPeriodicSaleReport
					INSERT INTO LOCAL_LOG (baseName, rec_id,operation,term) VALUES ('PeriodicSaleReports', @IdPeriodicSaleReport, 4, @@SPID)
				END
				ELSE
					EXEC hm.RecalculatePeriodicSaleReport NULL, @IdPeriodicSaleReport

				EXEC hm.IsDocumentAsPeriodicSaleReport @DKid = @id
			END
			ELSE
				EXEC hm.IsDocumentAsPeriodicSaleReport @DKid = @id
		END		
	END
	ELSE
	BEGIN 		
		UPDATE HM.DK SET IdPeriodicSaleReport = NULL WHERE id  = @id
		IF ((SELECT COUNT(id) FROM hm.DK WHERE IdPeriodicSaleReport = @IdPeriodicSaleReport) = 0)
		BEGIN
			DELETE FROM hm.PeriodicSaleReports WHERE Id = @IdPeriodicSaleReport
			INSERT INTO LOCAL_LOG (baseName, rec_id,operation,term) VALUES ('PeriodicSaleReports', @IdPeriodicSaleReport, 4, @@SPID)
		END
		ELSE
			EXEC hm.RecalculatePeriodicSaleReport NULL, @IdPeriodicSaleReport
	END